use picodata_sdk::tarantool;
use picodata_sdk::types;
use picodata_sdk::PluginVtable;

struct Plugin1 {}

/// It must be here? but can't because of macro use
// define_rpc_request! {
//     fn proc_ping(_req: Request) -> Result<Response, String> {
//         Ok(Response {response: "pong".to_string(),})
//     }

//     pub struct Request {
//         pub some_field: String,
//     }

//     pub struct Response {
//         pub response: String,
//     }

// }

// impl Request {
//     pub fn new(ping_message: String) -> Self {
//         Self {
//             some_field: ping_message,
//         }
//     }
// }

impl PluginVtable for Plugin1 {
    #[no_mangle]
    fn name() -> &'static str {
        "plugin 1"
    }

    #[no_mangle]
    fn online() {
        println!("PLUGIN 1 ONLINE CALLBACK");
        let lua = tarantool::lua_state();

        // still need to test it somehow
        match lua.exec(
            "pico.sql([[
            create table 'characters' (
            'id' integer,
            'name' text not null,
            'year' integer,
            primary key ('id')
        )
        using memtx distributed by ('id')
        option (timeout = 3.0) ;
        ]], {})",
        ) {
            Ok(_) => println!("PLUGIN 1 pico.sql succeed"),
            Err(err) => println!("PLUGIN 1 pico.sql failed: {:?}", err),
        }

        match lua.exec("pico.sql([[insert into \"characters\" (\"id\", \"name\", \"year\") values (10, 'Duke Caboom', 2019) ;]])") {
            Ok(_) => println!("PLUGIN 1 pico.sql succeed"),
            Err(err) => println!("PLUGIN 1 pico.sql failed: {:?}", err),
        }

        // must fail
        match lua.exec("pico.sql([[insert into \"assets\" values (1, 'Woody', 2561)]], {})") {
            Ok(_) => println!("PLUGIN 1 pico.sql succeed"),
            Err(err) => println!("PLUGIN 1 pico.sql failed: {:?}", err),
        }

        match lua.exec("pico.sql([[select * from \"characters\"]], {})") {
            Ok(_) => println!("PLUGIN 1 pico.sql succeed"),
            Err(err) => println!("PLUGIN 1 pico.sql failed: {:?}", err),
        }
    }

    #[no_mangle]
    fn shutdown() {
        println!("PLUGIN 1 STOP CALLBACK");
        let req = types::Request::new("PLUGIN 1 PING MESSAGE".to_string());
        let rpc = types::network_call("127.0.0.1:3302", &req);
        match tarantool::fiber::block_on(rpc) {
            Ok(fut_res) => println!("PLUGIN 1 rpc sent successfully: resp {:?}", fut_res),
            Err(err) => println!("PLUGIN 1 rpc sending failed {err}"),
        }
    }
}
